#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <search.h>
#include <time.h>
#include <math.h>
#include "ge.h"

#define NUM 12
#define PNUM 11

using namespace std;

long max(long x, long y)
{
	if (x>y)
		return x;
	else return y;
}

long min(long x, long y)
{
	if (x<y)
		return x;
	else return y;
}

int main(int argv, char * argc[])
{
	FILE *fpc,*fpc2,*fpc3,*fpc4,*fpc5,*fpc6,*fp;
	char fnc[1024],fnc2[1024],fnc3[1024],fnc4[1024],temp[1024],fnc5[1024],fnc6[1024];
	long s[NUM][PNUM];
	long i,j,l,m,N,K;
	int *mark,rd,*v1,*v2;
	int expid,**data,**est;
	long ins,dlt,upd,j1,j2;
	double d[NUM];
	
	srand((unsigned)time(NULL));

	if (argv!=3)
	{
		printf("parameter error!\n");
		return 0;
	}
	
	expid=atoi(argc[1]);
	sprintf(fnc,"./%s/config",argc[2]); 
	sprintf(fnc2,"./%s/existing_table.txt",argc[2]);
	sprintf(fnc3,"./%s/new_table.txt",argc[2]);
	sprintf(fnc4,"./%s/customer_table.txt",argc[2]);
	sprintf(fnc5,"./%s/insert_table.txt",argc[2]);  
  sprintf(fnc6,"./%s/delete_table.txt",argc[2]); 
	
	
	if((fp=fopen("uprealsetting.txt","r"))==NULL)
	{
		printf("Cannot open file!\n");
		return (0);
	}	
	
	for(i=0;i<NUM;i++)
	{
		for(j=0;j<PNUM;j++)
		{
			fscanf(fp,"%s",temp);
			if(j!=5)
				s[i][j]=atoi(temp);
			else 
				d[i]=atof(temp);
		}
	}
	
	fclose(fp);
	
	if((fpc=fopen(fnc,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc);
		return (0);
	}	
	
	for(j=3;j<PNUM;j++)
	{
		if(j!=8)
		{
		if(j!=5)
			fprintf(fpc,"%d ",s[expid-1][j]);
		else 
			fprintf(fpc,"%f ",d[expid-1]);
		}
	}
	fprintf(fpc,"\n");
	fclose(fpc);
	
	
	v1=(int *)malloc(sizeof(int)*s[expid-1][2]);
	v2=(int *)malloc(sizeof(int)*s[expid-1][2]);

/*	
	if((fpc2=fopen(fnc2,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc2);
		return (0);
	}	
	
		
	if((fpc3=fopen(fnc3,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc3);
		return (0);
	}
	
	//generate existing_table.txt		
	//generate new_table.txt	
	
//ge(s[expid-1][0],s[expid-1][1],s[expid-1][2],fpc3,fpc2);

	
	fclose(fpc2);
	
	fclose(fpc3);
*/
	sprintf(temp,"cp ./realdata/exsiting_table.txt.real %s",fnc2); 
	system(temp);
	sprintf(temp,"cp ./realdata/new_table.txt.real %s",fnc3); 
	system(temp);
	
/*	if((fpc4=fopen(fnc4,"w+"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc4);
		return (0);
	}
	
	printf("test\n");
*/
	//generate customer_table.txt
//	fprintf(fpc4,"%d %d\n",s[expid-1][8],s[expid-1][2]);
	ins=s[expid-1][8];
	dlt=s[expid-1][9];
	upd=s[expid-1][10];
	
	if (ins==0 && dlt==0 && upd>0)
	{
		ins=upd/2;
		dlt=upd/2;
	}
	mark=(int *)malloc(sizeof(int)*(s[expid-1][0]+ins));
	for(i=0;i<s[expid-1][0]+ins;i++)
		mark[i]=0;
	
	data=(int **)malloc(sizeof(int *)*(s[expid-1][0]+ins));
	est=(int **)malloc(sizeof(int *)*(s[expid-1][1]));
	for(i=0;i<s[expid-1][0]+ins;i++)
	{
		data[i]=(int *)malloc(sizeof(int)*s[expid-1][2]);
	}
	for(i=0;i<s[expid-1][1];i++)
	{
		est[i]=(int *)malloc(sizeof(int)*s[expid-1][2]);
	}
	if((fpc2=fopen(fnc2,"r"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc2);
		return (0);
	}	
	
	fscanf(fpc2,"%s",temp);
	//j1=atoi(temp);
	fscanf(fpc2,"%s",temp);
	//j2=atoi(temp);
	
	for(i=0;i<s[expid-1][0];i++)
	{
		for(j=0;j<s[expid-1][2];j++)
		{
			fscanf(fpc2, "%s", temp);
			data[i][j]=atoi(temp);
		}
	}
	fclose(fpc2);
// generate ins 1	
// geins(s[expid-1][8],s[expid-1][2],fpc4);
// generate ins 2
	/*
	printf("%ld,%ld\n",ins, s[expid-1][1]);
	fprintf(fpc4,"%d %d\n",ins,s[expid-1][2]);
	for(i=0;i<ins;i++)
	{
		
		rd=rand()%s[expid-1][1];
		
		while(mark[rd]==1)
		{
			rd=rand()%s[expid-1][1];
		}
		mark[rd]=1;
	}
	printf("done\n");
	for(i=0;i<s[expid-1][1];i++)
	{
		if(mark[i]==1)
		{
			for(j=0;j<s[expid-1][2];j++)
			{
				fprintf(fpc4,"%d",data[i][j]);
				if (j!=s[expid-1][2]-1);
					fprintf(fpc4," ");
			}			
			fprintf(fpc4,"\n");
			
		}
	}
	



	fclose(fpc4);
	
	*/
	if((fpc3=fopen(fnc3,"r"))==NULL)
	{
		printf("Cannot open file %s!\n",fnc3);
		return (0);
	}	
	
	fscanf(fpc3,"%s",temp);
	//j1=atoi(temp);
	fscanf(fpc3,"%s",temp);
	//j2=atoi(temp);
	
	for(i=0;i<s[expid-1][1];i++)
	{
		for(j=0;j<s[expid-1][2];j++)
		{
			fscanf(fpc3, "%s", temp);
			est[i][j]=atoi(temp);
		}
	}
	fclose(fpc3);
	if(ins>0 && dlt==0)
	{
			
		if((fpc5=fopen(fnc5,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc5);
			return (0);
		}
		//gecp(ins,s[expid-1][2],fpc5);
		fprintf(fpc5,"%d %d\n",ins,s[expid-1][2]);
		for(i=0;i<ins;i++)
		{
			
			rd=rand()%(s[expid-1][1]);
			for(j=0;j<s[expid-1][2];j++)
				v1[j]=est[rd][j];		
			rd=rand()%(s[expid-1][1]);
			for(j=0;j<s[expid-1][2];j++)
				v2[j]=est[rd][j];	
			for(j=0;j<s[expid-1][2];j++)
			{
				v1[j]=floor((double)(v1[j]+v2[j])/2);
				fprintf(fpc5,"%d ",v1[j]);
			}
			fprintf(fpc5,"\n");
			
		}
		fclose(fpc5);
	}
	if(ins>0 && dlt>0)
	{
		if((fpc5=fopen(fnc5,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc5);
			return (0);
		}
		fprintf(fpc5,"%d %d\n",ins,s[expid-1][2]);
		for(i=0;i<ins;i++)
		{
			
			rd=rand()%(s[expid-1][1]);
			for(j=0;j<s[expid-1][2];j++)
				v1[j]=est[rd][j];		
			rd=rand()%(s[expid-1][1]);
			for(j=0;j<s[expid-1][2];j++)
				v2[j]=est[rd][j];	
			for(j=0;j<s[expid-1][2];j++)
			{
				v1[j]=floor((double)(v1[j]+v2[j])/2.0);
				fprintf(fpc5,"%d ",v1[j]);
				
			}
			fprintf(fpc5,"\n");
			
		}
		fclose(fpc5);
		if((fpc5=fopen(fnc5,"r"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc5);
			return (0);
		}	
		
		fscanf(fpc5,"%s",temp);
		//j1=atoi(temp);
		fscanf(fpc5,"%s",temp);
		//j2=atoi(temp);
		
		for(i=0;i<ins;i++)
		{
			for(j=0;j<s[expid-1][2];j++)
			{
				fscanf(fpc5, "%s", temp);
				data[i+s[expid-1][0]][j]=atoi(temp);
			}
		}
		fclose(fpc5);
		if((fpc6=fopen(fnc6,"w+"))==NULL)
		{
			printf("Cannot open file %s!\n",fnc6);
			return (0);
		}	
		
		fprintf(fpc6,"%d %d\n",dlt,s[expid-1][2]);
		for(i=0;i<dlt;i++)
		{
			
			rd=rand()%(s[expid-1][0]+ins);
			
			while(mark[rd]==1)
			{
				rd=rand()%(s[expid-1][0]+ins);
			}
			mark[rd]=1;
		}
		printf("done\n");
		for(i=0;i<(s[expid-1][0]+ins);i++)
		{
			if(mark[i]==1)
			{
				for(j=0;j<s[expid-1][2];j++)
				{
					fprintf(fpc6,"%d",data[i][j]);
					if (j!=s[expid-1][2]-1);
						fprintf(fpc6," ");
				}			
				fprintf(fpc6,"\n");
				
			}
		}	
		fclose(fpc6);
	}


	
}
